set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_library(breakpad_common md5.cc module.cc simple_string_dictionary.cc string_conversion.cc convert_UTF.c long_string_dictionary.cc)

target_include_directories(breakpad_common PRIVATE ${PROJECT_SOURCE_DIR}/src/testing)
target_include_directories(breakpad_common PRIVATE ${PROJECT_SOURCE_DIR}/src/testing/googletest/include)
target_include_directories(breakpad_common PRIVATE ${PROJECT_SOURCE_DIR}/src/testing/googlemock/include)

target_include_directories(breakpad_common PUBLIC ${PROJECT_SOURCE_DIR}/src)

if(UNIX)
   target_sources(breakpad_common PRIVATE stabs_reader.cc)
   target_sources(breakpad_common PRIVATE stabs_to_module.cc)
   target_sources(breakpad_common PRIVATE dwarf_cfi_to_module.cc)
   target_sources(breakpad_common PRIVATE dwarf_cu_to_module.cc)
   target_sources(breakpad_common PRIVATE dwarf_line_to_module.cc)
   target_sources(breakpad_common PRIVATE language.cc)
   target_sources(breakpad_common PRIVATE path_helper.cc)
endif()

if(APPLE)
   target_compile_definitions(breakpad_common PRIVATE -DHAVE_MACH_O_NLIST_H)
   target_sources(breakpad_common PRIVATE mac/GTMLogger.m)
   target_sources(breakpad_common PRIVATE mac/MachIPC.mm)
   target_sources(breakpad_common PRIVATE mac/arch_utilities.cc)
   target_sources(breakpad_common PRIVATE mac/bootstrap_compat.cc)
   target_sources(breakpad_common PRIVATE mac/file_id.cc)
   target_sources(breakpad_common PRIVATE mac/launch_reporter.cc)
   target_sources(breakpad_common PRIVATE mac/macho_id.cc)
   target_sources(breakpad_common PRIVATE mac/macho_reader.cc)
   target_sources(breakpad_common PRIVATE mac/macho_utilities.cc)
   target_sources(breakpad_common PRIVATE mac/macho_walker.cc)
   target_sources(breakpad_common PRIVATE mac/string_utilities.cc)
   target_sources(breakpad_common PRIVATE mac/dump_syms.cc)
elseif(WIN32)
    find_package(DiaSDK REQUIRED)
    target_include_directories(breakpad_common PUBLIC ${DIASDK_INCLUDE_DIRS})
    if(MSVC)
      set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
      set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    target_sources(breakpad_common PRIVATE windows/dia_util.cc)
    target_sources(breakpad_common PRIVATE windows/guid_string.cc)
    target_sources(breakpad_common PRIVATE windows/omap.cc)
    target_sources(breakpad_common PRIVATE windows/pdb_source_line_writer.cc)
    target_sources(breakpad_common PRIVATE windows/string_utils.cc)
elseif(UNIX)
    target_compile_definitions(breakpad_common PRIVATE -DHAVE_A_OUT_H)
    if(NOT ANDROID)
        target_sources(breakpad_common PRIVATE linux/crc32.cc)
        target_sources(breakpad_common PRIVATE linux/dump_symbols.cc)
        target_sources(breakpad_common PRIVATE linux/elf_core_dump.cc)
        target_sources(breakpad_common PRIVATE linux/elf_symbols_to_module.cc)
        target_sources(breakpad_common PRIVATE linux/elfutils.cc)
        target_sources(breakpad_common PRIVATE linux/file_id.cc)
        target_sources(breakpad_common PRIVATE linux/guid_creator.cc)
        target_sources(breakpad_common PRIVATE linux/linux_libc_support.cc)
        target_sources(breakpad_common PRIVATE linux/memory_mapped_file.cc)
        target_sources(breakpad_common PRIVATE linux/safe_readlink.cc)
        target_sources(breakpad_common PRIVATE linux/synth_elf.cc)
    endif()
endif()


if(UNIX)
    subdirs(dwarf)
    target_link_libraries(breakpad_common breakpad_common_dwarf)
endif()
